#ifndef SHA1_MORE_H
#define SHA1_MORE_H
#include <sstream>      /* for stringsream */
#include <arpa/inet.h>  /* for htonl */

struct Digest {
  union{
    unsigned int word[5];
    unsigned char byte[20];
  };
  Digest(char const * str){
    stringstream parse;
    parse.str(str);
    unsigned int temp;
    for (int ii = 0; ii < 5; ii++){
      parse >> hex >> temp;
      word[ii] = htonl(temp);
    }
  }
// typically val=0 :
  Digest(int const val){
    for (int ii = 0; ii < 5; ii++){
      word[ii] = val;
    }
  }
  Digest(){};
  int operator==(const Digest& other) const {
    for (int ii = 0; ii < 5; ii++) {
      if (word[ii] != other.word[ii]) return 0;
    }
    return 1;
  }
};
#endif
